hdoj4407题解

  题目描述:1,2,3.....n排一行(1<=n<=400000),接下来有m(1<=m<=1000)操作,操作分为两种,一种是查询,一种是改值。

    查询:输入x,y,p,求第x个数到第y个数之间与p互质的数的和
    改值:输入x,c,将第x个数的值改为c

  这题用到容斥原理,先认为第x到第y个数是连续的,对于连续的数求与p互质的数的和可以用第x个数到第y个数的和减去与p有公约数的和。

对于改值,用个数组记录下来要修改的数的下标和修改之后的值

连续的数列求完之后再遍历这个数组,若修改的数的下标落在x到y这个区间之内,则进行替换。

  

  400000以内的数的质约数的最多只有7个,所以求连续的数列与p互质的和的时间复杂度是2*7*2^7,不超过1000次,遍历数组也不会超过1000次,所以对于任意一步操作计算的次数不超过2000次,再乘以1000步操作,所以计算量不会超过2000000次。

#include <iostream>
#include <cstdio>
#include <cmath>
using namespace std;
int n;
int m;
int yueshu[20];
int nyueshu;

struct Node
{
    int index;
    int value;
};
Node node[1010];
int nnode;

void Initialize()
{
    nnode=0;
}

int IsCoprime(int a)
{
    int i;
    for(i=1;i<=nyueshu;i++)
    {
        if(a%yueshu[i]==0)
        {
            return 0;
        }
    }
    return 1;
}

void GetYueshu(int p)
{
    nyueshu=0;
    int a=(int)sqrt((double)p);
    int i;
    for(i=2;i<=a;i++)
    {
        if(p%i==0)
        {
            nyueshu++;
            yueshu[nyueshu]=i;
        }
        while(p%i==0)
        {
            p=p/i;
        }
    }
    if(p!=1)
    {
        nyueshu++;
        yueshu[nyueshu]=p;
    }
}

__int64 Get(__int64 a)
{
    if(a==0)
    {
        return 0;
    }
     __int64 sum=(a+1)*a/2;
     int b[20];
     int num=(int)pow((double)2,(double)nyueshu)-1;
     int i;
     int j;
     int temp;
     __int64 cj;
     int geshu;
     for(i=1;i<=num;i++)
     {
          temp=i;
          for(j=1;j<=nyueshu;j++)
          {
              b[j]=temp%2;
              temp=temp/2;
          }
          cj=1;
          geshu=0;
          for(j=1;j<=nyueshu;j++)
          {
              if(b[j]==1)
              {
                  cj*=yueshu[j];
                  geshu++;
              }
          }
          if(geshu%2==1)
          {
               sum-=((1+a/cj)*(a/cj)/2*cj);
          }
          else
          {
              sum+=((1+a/cj)*(a/cj)/2*cj);
          }
     }
     return sum;
}

__int64 GetValue(int l,int r,int p)
{
    GetYueshu(p);
    __int64 sum=Get(r)-Get(l-1);
    int i;
    for(i=1;i<=nnode;i++)
    {
        if(l<=node[i].index&&r>=node[i].index)
        {
            if(IsCoprime(node[i].index)==1)
            {
                 sum-=node[i].index;
            }
            if(IsCoprime(node[i].value)==1)
            {
                sum+=node[i].value;
            }
        }
    }
    return sum;
}

void Insert(int index,int value)
{
    int i;
    for(i=1;i<=nnode;i++)
    {
        if(node[i].index==index)
        {
            node[i].value=value;
            return ;
        }
    }
    nnode++;
    node[nnode].index=index;
    node[nnode].value=value;
}

int main()
{
    int t;
    int T;
    int i;
    int operate;
    int l;
    int r;
    int p;
    int index;
    int value;
    scanf("%d",&T);
    for(t=1;t<=T;t++)
    {
        scanf("%d%d",&n,&m);
        Initialize();
        for(i=1;i<=m;i++)
        {
            scanf("%d",&operate);
            if(operate==1)
            {
                scanf("%d%d%d",&l,&r,&p);
                printf("%I64d\n",GetValue(l,r,p));
            }
            else
            {
                scanf("%d%d",&index,&value);
                Insert(index,value);
            }
        }
    }
    return 0;
}
 
时间: 2024-08-01 08:20:13

hdoj4407题解的相关文章

洛谷 P1079 Vigen&#232;re 密码 题解

此文为博主原创题解,转载时请通知博主,并把原文链接放在正文醒目位置. 题目链接:https://www.luogu.org/problem/show?pid=1079 题目描述 16 世纪法国外交家 Blaise de Vigenère 设计了一种多表密码加密算法――Vigenère 密 码.Vigenère 密码的加密解密算法简单易用,且破译难度比较高,曾在美国南北战争中为 南军所广泛使用. 在密码学中,我们称需要加密的信息为明文,用 M 表示:称加密后的信息为密文,用 C 表示:而密钥是一种

8.8联考题解

今天的T1让我怀疑我是不是在做奥赛题--这考的是什么知识点啊这个,会不会用绝对值函数? Evensgn 的债务 时间限制: 1 Sec  内存限制: 128 MB 题目描述 Evensgn 有一群好朋友,他们经常互相借钱.假如说有三个好朋友A,B,C.A 欠 B 20 元,B 欠 C 20 元,总债务规模为 20+20=40 元.Evensgn 是个追求简约的人,他觉得这样的债务太繁杂了.他认为,上面的债务可以完全等价为 A 欠C20 元,B 既不欠别人,别人也不欠他.这样总债务规模就压缩到了 

POJ 2533 - Longest Ordered Subsequence(最长上升子序列) 题解

此文为博主原创题解,转载时请通知博主,并把原文链接放在正文醒目位置. 题目链接:http://poj.org/problem?id=2533 Description A numeric sequence of ai is ordered if a1 < a2 < ... < aN. Let the subsequence of the given numeric sequence (a1, a2, ..., aN) be any sequence (ai1, ai2, ..., aiK)

(leetcode题解)Pascal&#39;s Triangle

Pascal's Triangle  Given numRows, generate the first numRows of Pascal's triangle. For example, given numRows = 5,Return [ [1], [1,1], [1,2,1], [1,3,3,1], [1,4,6,4,1] ] 题意实现一个杨辉三角. 这道题只要注意了边界条件应该很好实现出来,C++实现如下 vector<vector<int>> generate(int

2017ZZUACM省赛选拔试题部分题解----谨以纪念我这卡线滚粗的美好经历

写在前面: 其实心里有些小小的不爽又有点小小的舒畅,为啥捏?不爽当然是因为没被选拔上啦,舒畅捏则是因为没被选拔上反而让自己警醒,学长也提点很多很多."沉下去,然后一战成名"学长如是对我说,我很开心.其实这完全算不算是题解,只是我个人的一些小想法而已.而且到现在还有一题不会...让自己长点记性吧. 题目 A :聪明的田鼠 Time Limit: 1 Sec Memory Limit: 128 MB Description 田鼠MIUMIU来到了一片农田,农田可以看成是一个M*N个方格的矩

LeetCode-001题解

此题目摘自LeetCode001 Given an array of integers, find two numbers such that they add up to a specific target number. The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2.

leetcode题解: Next Permutation

最近还一直在刷leetcode,当然,更多时候只是将题解写在自己的电脑上,没有分享出来.偶尔想起来的时候,就写出来. public class Solution { public void nextPermutation(int[] nums) { if(nums==null||nums.length<=1) return; nextPermutationHelp( nums,0,nums.length-1); } public void nextPermutationHelp(int []nu

HDU 5014 Number Sequence(2014 ACM/ICPC Asia Regional Xi&#39;an Online) 题解

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5014 Number Sequence Problem Description There is a special number sequence which has n+1 integers. For each number in sequence, we have two rules: ● ai ∈ [0,n] ● ai ≠ aj( i ≠ j ) For sequence a and sequ

HDU 1045 Fire Net 二分图Bipartite题解

本题可以使用DFS直接爆搜出答案,不过这样类型的题目其实是个二分图的题解. 这个二分图,难不在Hungary算法,而是难在于建图.需要挺高的抽象思维的. 建图: 1 把同一行不被X分开的格子标同一个号码,被X分开的标下一个号码,这样做是为了缩点,不需要把所有的格子都分开标号,而且可以更方便建个更加小的图. 2 同理把同一列的格子标号 3 然后判断相同一个格子的行标号和列标号是有路径的,其他不在同一个格子的都是没有路径的. 4 这样就等于以行标号和列标号作为左右顶点,构建成一个二分图了 然后使用H